<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <title>Cuti Approval API</title>

    <link rel="stylesheet" href="/css/bootstrap.min.css">

</head>

<body class="bg-light">
    <nav class="navbar navbar-expand-lg navbar-light bg-white border-bottom">
        <a class="navbar-brand" href="#">Cuti Approval</a>
    </nav>
    <div class="container-fluid">
        <div class="row" style="min-height: 93.8vh">
            <div class="col-md-2 bg-white shadow">
                <div class="list-group mt-3">
                    <a href="/jenis_cuti/index" class="list-group-item list-group-item-action ">Jenis Cuti</a>
                    <a href="/jenis_karyawan/index" class="list-group-item list-group-item-action ">Jenis Karyawan</a>
                    <a href="/karyawan/index" class="list-group-item list-group-item-action">Karyawan</a>
                    <a href="/status/index" class="list-group-item list-group-item-action">Status</a>
                    <a href="/cuti/index" class="list-group-item list-group-item-action ">Cuti</a>
                    <a href="/cuti_approval/index" class="list-group-item list-group-item-action active">Cuti Approval</a>
                </div>
            </div>
            <div class="col-md-10">
                <div class="card mt-3">
                    <div class="card-body shadow">
                        <h2> Cuti Approve API</h2>
                        <p>
                            <button class="btn btn-primary" onclick="OpenList(0, 5)">Open List</button>
                            <!--<button class="btn btn-primary" onclick="OpenForm()">Open Add Form</button>-->
                        </p>
                        <input class="form-control" type="text" placeholder="Search" onkeyup="SearchCuti(this.value)" autocomplete="off">
                        <div id="cutiList"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script src="/js/jquery-3.5.1.min.js"></script>
    <script src="/js/bootstrap-bundle.min.js"></script>

    <script>
        function OpenList() {
            $.ajax({
                url: '/api/cuti',
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var table = '<table class="table table-hover">';

                    table += "<tr>";
                    table += "<th> # </th>";
                    table += "<th> ID Cuti </th>";
                    table += "<th> Jenis Cuti </th>";
                    table += "<th> Tanggal Mulai </th>";
                    table += "<th> Tanggal Akhir</th>";
                    table += "<th> Lama Cuti </th>";
                    table += "<th> Status </th>";
                    table += "<th> Action</th>";
                    table += "</tr>";

                    for (let i = 0; i < data.length; i++) {
                        if (data[i].statusId == 1) {
                            table += "<tr>";
                            table += "<td>" + (i + 1) + "</td>";
                            table += "<td>" + data[i].id + "</td>";
                            table += "<td>" + data[i].jenisCuti.nama + "</td>";
                            table += "<td>" + data[i].tanggalAwal + "</td>";
                            table += "<td>" + data[i].tanggalAkhir + "</td>";
                            table += "<td>" + data[i].lamaCuti + ' Hari' + "</td>";
                            table += "<td>" + data[i].status.status + "</td>";
                            table += "<td><button class='btn btn-primary' value='" + data[i].id + "' onclick='formApproval(this.value)'>Approve</button></td>";
                            table += "</tr>"
                        }
                    }
                    table += "</table>";
                    $('#cutiList').html(table);
                }
            });
        }

        function formApproval(id) {
            $.ajax({
                url: '/api/cuti/' + id,
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered">';
                    $.ajax({
                        url: '/api/status/',
                        type: 'GET',
                        contentType: 'application/json',
                        success: function(dataStatus) {
                            $.ajax({
                                url: '/api/jenis_cuti/',
                                type: 'GET',
                                contentType: 'application/json',
                                success: function(dataJenisCuti) {
                                    form += "<tr>";
                                    form += "<td>Id Cuti</td>";
                                    form += '<td><input class="form-control" type="text" id="cuti_id" value="' + data.id + '" disabled></td>';
                                    form += '<input class="form-control" type ="hidden" id="jenisId" value="' + data.jenisCuti.id + '">';
                                    form += "<tr>";
                                    form += "<td>Jenis Cuti </td>"
                                    form += "<td><select class='custom-select' id='jenis_cuti_id' disabled>"
                                    for (let i = 0; i < dataJenisCuti.length; i++) {
                                        if (dataJenisCuti[i].id == data.jenisCutiId) {
                                            selected = "selected"
                                        } else {
                                            selected = ""
                                        }
                                        form += "<option value='" + dataJenisCuti[i].id + "' " + selected + ">" + dataJenisCuti[i].nama + "</option>"
                                    }
                                    form += "<tr>";
                                    form += "<td>Status </td>"
                                    form += "<td><select class='custom-select' id='status_id'>"
                                    for (let i = 0; i < dataStatus.length; i++) {
                                        if (dataStatus[i].id == data.statusId) {
                                            selected = "selected"
                                        } else {
                                            selected = ""
                                        }
                                        form += "<option value='" + dataStatus[i].id + "' " + selected + ">" + dataStatus[i].status + "</option>"
                                    }
                                    form += "</select></td>";
                                    form += "</tr>"
                                    form += "<td>Keterangan</td>";
                                    form += "<td><input class='form-control' type='text' id='keterangan'>";
                                    form += "</tr>";
                                    form += '<input class="form-control" type ="hidden" id="tanggal_mulai" value="' + data.tanggalAwal + '">';
                                    form += '<input class="form-control" type ="hidden" id="tanggal_akhir" value="' + data.tanggalAkhir + '">';
                                    form += '<input class="form-control" type ="hidden" id="lama" value="' + data.lamaCuti + '">';
                                    form += '<input class="form-control" type="hidden" id="created_on" value="' + data.createdOn + '">';
                                    form += '<input class="form-control" type="hidden" id="created_by" value="' + data.createdBy + '">';
                                    form += "<tr>";
                                    form += '<td colspan="2"><button class="btn btn-primary" value="' + data.id + '" onclick="ApproveCuti(this.value)">Save</button></td>';
                                    form += '</tr>';
                                    $('#cutiList').html(form);
                                }
                            });
                        }
                    });
                }
            });
        }



        function ApproveCuti(id) {
            var formData = '{';
            formData += '"cutiId":"' + $('#cuti_id').val() + '",';
            formData += '"statusId":"' + $('#status_id').val() + '",';
            formData += '"keterangan":"' + $('#keterangan').val() + '"';
            formData += '}';

            $.ajax({
                url: '/api/cuti_approval/',
                type: 'post',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList();
                    var formDataCuti = '{';
                    formDataCuti += '"cutiId":"' + $('#cuti_id').val() + '",';
                    formDataCuti += '"statusId":"' + $('#status_id').val() + '",';
                    formDataCuti += '"jenisCutiId":"' + $('#jenis_cuti_id').val() + '",';
                    formDataCuti += '"tanggalAwal":"' + $('#tanggal_mulai').val() + '",';
                    formDataCuti += '"tanggalAkhir":"' + $('#tanggal_akhir').val() + '",';
                    formDataCuti += '"lamaCuti":"' + $('#lama').val() + '"';
                    formDataCuti += '}';

                    $.ajax({
                        url: '/api/cuti/' + id,
                        type: 'put',
                        contentType: 'application/json',
                        data: formDataCuti,
                        success: function(data) {
                            OpenList();
                        }
                    });
                }
            });
        }
    </script>